/*
 * Timer, copyright (c) 2015-21 Irwin Associates
 * www.irwinassociates.eu/timers/
 * To anyone who acknowledges that this file and associate files 
 * are provided "AS IS" without any express or implied warranty, 
 * permission to use, copy, modify and distribute these file for 
 * any purpose is hereby granted without fee, provided that this 
 * notice appears in all copies. The author makes no representations
 * about the suitability of this software for any purpose.
 */

// display timer
function showTime() {
  var hours = Math.floor(timex / 3600);
  var mins = Math.floor((timex - (hours * 3600)) / 60);
  var secs = timex % 60;
  var hh = hours < 10 ? "0" + hours : hours;
  var mm = mins < 10 ? "0" + mins : mins;
  var ss = secs < 10 ? "0" + secs : secs;
  var time = hh + ":" + mm + ":" + ss;
  document.querySelector("#theTime").innerHTML = time;
  document.querySelector("#theName").value = tName;
  document.title = tName + ": " + time;
  timex++;
}

// start button - start timer
btnStart.addEventListener("click", function() {
  document.querySelector("#btnStart").className = "hide";
  document.querySelector("#btnStop").className = "";
  intId = setInterval(showTime, 1000);
  running = true;
  setUnload(true);
});

// stop button - stop timer
btnStop.addEventListener("click", function() {
  document.querySelector("#btnStop").className = "hide";
  document.querySelector("#btnStart").className = "";
  clearInterval(intId);
  running = false;
});

// reset button - clear timer
btnReset.addEventListener("click", function() {
  // don't allow reset if timer is running
  if (!running) {
    if (confirm("Are you sure?")) {
      timex = 0;
      showTime();
      setUnload(false);
    }
  }
});

// change timer title
btnChange.addEventListener("click", function() {
  thA = document.changeForm.titleA.value;
  if (thA != "") {
    tName = thA;
    --timex;
    showTime();
  }
});

function unloadMsg() {
  msg = "You may have a timer running."
  return msg;
}

// set unload message on/off
function setUnload(on) {
  window.onbeforeunload = (on) ? unloadMsg : null;
}

// initialise the timer
let tName = "Timer",
  running = false,
  timex = 0;
showTime();
setUnload(false);
